#ifndef _OA_H_
#define _OA_H_

#include <cmath>

// used in other definitions
#define OA_BLOCK_SIZE		1024
#define OA_FILE_BLOCKS		7	//How many blocks does the file consist of?
#define OA_BLOCKS_UPDATED	2	//How many blocks get updated at each round? 
#define OA_TAG_SIZE			24

// used in code
#define OA_METADATA_SIZE 	164

// used in code - not meant to be changed!
#define OA_FILE_SIZE	OA_BLOCK_SIZE * OA_FILE_BLOCKS
#define OA_UPDATE_SIZE	OA_BLOCK_SIZE * OA_BLOCKS_UPDATED
#define OA_PROOF_SIZE	ceil(log2(OA_FILE_BLOCKS)) * OA_TAG_SIZE * OA_BLOCKS_UPDATED

// dispute types detected by judge
#define OA_CLIENT_PAYS		0
#define OA_SERVER_PAYS		1
#define OA_DENIAL_OF_UPDATE	2
#define OA_CORRUPTION		3

// Contract information
#define OA_CONTRACT_PERIOD 		2592000 //seconds = 30 days
#define OA_MAX_UPDATES 			15 //times
#define OA_CONTRACT_TIME_ELASTICITY	3600 //seconds = 1 hour 

#endif

